#include <inttypes.h>
#include <string.h>
#include "bsp.h"
#include "led.h"
#include "spi.h"
#include "power.h"
#include "tty.h"

Reset ()
{
}

static int
diag_ade (int channel)
{
  int rev;
  long laenergy, lvaenergy, aenergy, irms, vrms;
  rev = power_getreg (channel, 0x3f);
  if (rev == 0xff)
    return 0;
  cprintf("%b.%b : ", channel+1, rev);

  laenergy = power_getreg (channel, LAENERGY);
  lvaenergy = power_getreg (channel, LVAENERGY);
  aenergy = power_getreg (channel, AENERGY);
  irms = power_getreg (channel, IRMS);
  vrms = power_getreg (channel, VRMS);

  cprintf("LAENERGY=%x ", &laenergy, 3);
  cprintf("LVAENERGY=%x ", &lvaenergy, 3);
  cprintf("AENERGY=%x ", &aenergy, 3);
  cprintf("IRMS=%x ", &irms, 3);
  cprintf("VRMS=%x ", &vrms, 3);
  cprintf("\n");
  if (lvaenergy)
    return 1;
  return 0;
}

static char twiddlec[] = "\\|/-";
static int twiddlei = 0;
#define twiddle tty_putc (twiddlec[(++twiddlei)&3]); tty_putc(8);

static unsigned char ledbits[] = { LED_GRN, LED_YEL, LED_BLU, LED_RED };

main()
{
  int lasttic = 0;
  unsigned int i, j;
  int leds;

  pd6.b = 0x0f;

  tty_init ();

  tty_puts("\npowermeter ready!\n");

  p6.b = 0;

  spi_reset ();
  power_init ();
  spi_power ();

#if 0
  pd3.b = 0xff;
  while (1)
    {
      i++;
      p3.b = i;
    }
#endif

  cprintf("\033[1;1H\033[2J");
  while (1)
    {
      leds = LED_OFF;

      cprintf("\033[1;1H");
      for (i=0; i<16; i++)
	{
	  if (diag_ade (i))
	    leds &= ledbits[i%4];
	  //power_getreg (15, 0x2a);
	}
      set_led (leds);
      cprintf("upsec %d %d\n", (int)(tics_long/1000L), uptime_seconds);
    }
}
