#ifndef _FLASH_H_
#define _FLASH_H_

/* Layout of the 2x 1k data flash */

#define DFLASH1_ADDR	0x2400
#define DFLASH2_ADDR	0x2800

#define flash_data (*(DataFlash *)DFLASH1_ADDR)

typedef struct {
  long magic;
  long id;
  word poll_sec;
  byte filler[32-10];
} DF_Header;

#define FLASH_MAGIC	0x5d95646aL

typedef struct {
  unsigned char mac_addr[6];
  unsigned char ip_addr[4];
  unsigned char gw_addr[4];
  unsigned char netmask[4];
  byte filler[32-18];
} DF_Ether;

typedef struct {
  word apos;
  word irmsos;
  word linecyc;
  word mode;
  word vagain;
  word vrmsos;
  word wgain;
  byte ch1os;
  byte ch2os;
  byte gain;
  byte phcal;
  byte vadiv;
  byte wdiv;
  byte scale;
  byte filler[32-21];
} DF_Power;

typedef struct {
  DF_Header header;
  DF_Ether ether;
  DF_Power power[16];
} DataFlash;

#define DF_SIZE (32 * (1+1+16))

extern void flash_init ();
extern void flash_cmdline ();

extern void calibrate (int channel, DF_Power *power);

#endif
