typedef unsigned char byte;

typedef unsigned short word;

typedef unsigned long dword;


typedef union {
  struct {
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte pm03:1;
    byte unspec_3:1;
    byte unspec_4:1;
    byte unspec_5:1;
    byte unspec_6:1;
  };
  byte b;
} pm0_type;
#define pm0 (*(volatile pm0_type *)0x04)

typedef union {
  struct {
    byte unspec_0:1;
    byte unspec_1:1;
    byte pm12:1;
    byte unspec_2:1;
    byte unspec_3:1;
    byte unspec_4:1;
    byte unspec_5:1;
    byte unspec_6:1;
  };
  byte b;
} pm1_type;
#define pm1 (*(volatile pm1_type *)0x05)

#define cm0 (*(volatile byte *)0x06)
#define cm1 (*(volatile byte *)0x07)

typedef union {
  struct {
    byte prc0:1;
    byte prc1:1;
    byte prc2:1;
    byte prc3:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
  };
  byte b;
} prcr_type;
#define prcr (*(volatile prcr_type *)0x0a)

typedef union {
  struct {
    byte ocd0:1;
    byte ocd1:1;
    byte ocd2:1;
    byte ocd3:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
  };
  byte b;
} ocd_type;
#define ocd (*(volatile ocd_type *)0x0c)

#define wdtr (*(volatile byte *)0x0d)
#define wdts (*(volatile byte *)0x0e)
#define wdc (*(volatile byte *)0x0f)
#define rmad0l (*(volatile byte *)0x10)
#define rmad0m (*(volatile byte *)0x11)
#define rmad0h (*(volatile byte *)0x12)
#define aier (*(volatile byte *)0x13)
#define rmad1l (*(volatile byte *)0x14)
#define rmad1m (*(volatile byte *)0x15)
#define rmad1h (*(volatile byte *)0x16)
#define cspr (*(volatile byte *)0x1c)
#define fra0 (*(volatile byte *)0x23)
#define fra1 (*(volatile byte *)0x24)
#define fra2 (*(volatile byte *)0x25)
#define vca1 (*(volatile byte *)0x31)
#define vca2 (*(volatile byte *)0x32)
#define vw1c (*(volatile byte *)0x36)
#define vw2c (*(volatile byte *)0x37)
#define trd0ic (*(volatile byte *)0x48)
#define trd1ic (*(volatile byte *)0x49)
#define treic (*(volatile byte *)0x4a)
#define kupic (*(volatile byte *)0x4d)
#define adic (*(volatile byte *)0x4e)
#define ssuic (*(volatile byte *)0x4f)
#define iicic (*(volatile byte *)0x4f)
#define s0tic (*(volatile byte *)0x51)
#define s0ric (*(volatile byte *)0x52)
#define s1tic (*(volatile byte *)0x53)
#define s1ric (*(volatile byte *)0x54)
#define int2ic (*(volatile byte *)0x55)
#define traic (*(volatile byte *)0x56)
#define trbic (*(volatile byte *)0x58)
#define int1ic (*(volatile byte *)0x59)
#define int3ic (*(volatile byte *)0x5a)
#define int0ic (*(volatile byte *)0x5d)

typedef union {
  struct {
    byte smd:3;
    byte ckdir:1;
    byte stps:1;
    byte pry:1;
    byte prye:1;
    byte unspec_0:1;
  };
  byte b;
} u0mr_type;
#define u0mr (*(volatile u0mr_type *)0xa0)

#define u0brg (*(volatile byte *)0xa1)
#define u0tb (*(volatile byte *)0xa2)

typedef union {
  struct {
    byte clk:2;
    byte unspec_0:1;
    byte txept:1;
    byte unspec_1:1;
    byte nch:1;
    byte ckpol:1;
    byte uform:1;
  };
  byte b;
} u0c0_type;
#define u0c0 (*(volatile u0c0_type *)0xa4)

typedef union {
  struct {
    byte te:1;
    byte ti:1;
    byte re:1;
    byte ri:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
  };
  byte b;
} u0c1_type;
#define u0c1 (*(volatile u0c1_type *)0xa5)

#define u0rb (*(volatile word *)0xa6)

typedef union {
  struct {
    byte smd:3;
    byte ckdir:1;
    byte stps:1;
    byte pry:1;
    byte prye:1;
    byte unspec_0:1;
  };
  byte b;
} u1mr_type;
#define u1mr (*(volatile u1mr_type *)0xa8)

#define u1brg (*(volatile byte *)0xa9)
#define u1tb (*(volatile byte *)0xaa)

typedef union {
  struct {
    byte clk:2;
    byte unspec_0:1;
    byte txept:1;
    byte unspec_1:1;
    byte nch:1;
    byte ckpol:1;
    byte uform:1;
  };
  byte b;
} u1c0_type;
#define u1c0 (*(volatile u1c0_type *)0xac)

typedef union {
  struct {
    byte te:1;
    byte ti:1;
    byte re:1;
    byte ri:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
  };
  byte b;
} u1c1_type;
#define u1c1 (*(volatile u1c1_type *)0xad)

#define u1rb (*(volatile word *)0xae)

typedef union {
  struct {
    byte cks:4;
    byte trs:1;
    byte mst:1;
    byte rcvd:1;
    byte ice:1;
  };
  byte b;
} iccr1_type;
#define iccr1 (*(volatile iccr1_type *)0xb8)

typedef union {
  struct {
    byte unspec_0:1;
    byte iicrst:1;
    byte unspec_1:1;
    byte sclo:1;
    byte sdaop:1;
    byte sdao:1;
    byte scp:1;
    byte bbsy:1;
  };
  byte b;
} iccr2_type;
#define iccr2 (*(volatile iccr2_type *)0xb9)

typedef union {
  struct {
    byte bc:3;
    byte bcwp:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte wait:1;
    byte mls:1;
  };
  byte b;
} icmr_type;
#define icmr (*(volatile icmr_type *)0xba)

typedef union {
  struct {
    byte ackbt:1;
    byte ackbr:1;
    byte acke:1;
    byte stie:1;
    byte makie:1;
    byte rie:1;
    byte teit:1;
    byte tie:1;
  };
  byte b;
} icier_type;
#define icier (*(volatile icier_type *)0xbb)

typedef union {
  struct {
    byte adz:1;
    byte aas:1;
    byte al:1;
    byte stop:1;
    byte nackf:1;
    byte rdrf:1;
    byte tend:1;
    byte tdre:1;
  };
  byte b;
} icsr_type;
#define icsr (*(volatile icsr_type *)0xbc)

typedef union {
  struct {
    byte fsb:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
    byte unspec_4:1;
    byte unspec_5:1;
    byte unspec_6:1;
  };
  byte b;
} sar_type;
#define sar (*(volatile sar_type *)0xbd)

#define icdrt (*(volatile byte *)0xbe)
#define icdrr (*(volatile byte *)0xbf)
#define ad (*(volatile word *)0xc0)

typedef union {
  struct {
    byte ch:3;
    byte md:1;
    byte adgsel0:1;
    byte adcap:1;
    byte adst:1;
    byte cks0:1;
  };
  byte b;
} adcon0_type;
#define adcon0 (*(volatile adcon0_type *)0xd6)

typedef union {
  struct {
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte bits:1;
    byte cks1:1;
    byte vcut:1;
    byte unspec_3:1;
    byte unspec_4:1;
  };
  byte b;
} adcon1_type;
#define adcon1 (*(volatile adcon1_type *)0xd7)

typedef union {
  struct {
    byte smp:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
    byte unspec_4:1;
    byte unspec_5:1;
    byte unspec_6:1;
  };
  byte b;
} adcon2_type;
#define adcon2 (*(volatile adcon2_type *)0xd4)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p0_type;
#define p0 (*(volatile p0_type *)0xe0)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p1_type;
#define p1 (*(volatile p1_type *)0xe1)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd0_type;
#define pd0 (*(volatile pd0_type *)0xe2)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd1_type;
#define pd1 (*(volatile pd1_type *)0xe3)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p2_type;
#define p2 (*(volatile p2_type *)0xe4)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p3_type;
#define p3 (*(volatile p3_type *)0xe5)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd2_type;
#define pd2 (*(volatile pd2_type *)0xe6)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd3_type;
#define pd3 (*(volatile pd3_type *)0xe7)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p4_type;
#define p4 (*(volatile p4_type *)0xe8)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd4_type;
#define pd4 (*(volatile pd4_type *)0xea)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} p6_type;
#define p6 (*(volatile p6_type *)0xec)

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte b;
} pd6_type;
#define pd6 (*(volatile pd6_type *)0xee)

#define pur0 (*(volatile byte *)0xfc)
#define pur1 (*(volatile byte *)0xfd)
#define u1sr (*(volatile byte *)0xf5)

typedef union {
  struct {
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
    byte u1pinsel:1;
    byte unspec_4:1;
    byte unspec_5:1;
    byte iicsel:1;
  };
  byte b;
} pmr_type;
#define pmr (*(volatile pmr_type *)0xf8)

typedef union {
  struct {
    byte int0en:1;
    byte int0pl:1;
    byte int1en:1;
    byte int1pl:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte int3en:1;
    byte int3pl:1;
  };
  byte b;
} inten_type;
#define inten (*(volatile inten_type *)0xf9)

typedef union {
  struct {
    byte int0f:2;
    byte int1f:2;
    byte unspec_0:1;
    byte unspec_1:1;
    byte int3f:2;
  };
  byte b;
} intf_type;
#define intf (*(volatile intf_type *)0xfa)

#define kien (*(volatile byte *)0xfb)
#define pur0 (*(volatile byte *)0xfc)
#define pur1 (*(volatile byte *)0xfd)

typedef union {
  struct {
    byte tstart:1;
    byte tcstr:1;
    byte tstop:1;
    byte unspec_0:1;
    byte tedgf:1;
    byte tundf:1;
    byte unspec_1:1;
    byte unspec_2:1;
  };
  byte b;
} tracr_type;
#define tracr (*(volatile tracr_type *)0x100)

typedef union {
  struct {
    byte tedgsel:1;
    byte topcr:1;
    byte toena:1;
    byte tiosel:1;
    byte tipf:2;
    byte unspec_0:1;
    byte unspec_1:1;
  };
  byte b;
} traioc_type;
#define traioc (*(volatile traioc_type *)0x101)

typedef union {
  struct {
    byte tmod:3;
    byte unspec_0:1;
    byte tck:3;
    byte tckcut:1;
  };
  byte b;
} tramr_type;
#define tramr (*(volatile tramr_type *)0x102)

#define trapre (*(volatile byte *)0x103)
#define tra (*(volatile byte *)0x104)

typedef union {
  struct {
    byte tstart:1;
    byte tcstr:1;
    byte tstop:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
    byte unspec_4:1;
  };
  byte b;
} trbcr_type;
#define trbcr (*(volatile trbcr_type *)0x108)

typedef union {
  struct {
    byte tosst:1;
    byte tossp:1;
    byte tosstf:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
    byte unspec_4:1;
  };
  byte b;
} trbocr_type;
#define trbocr (*(volatile trbocr_type *)0x109)

typedef union {
  struct {
    byte topl:1;
    byte tocnt:1;
    byte inostg:1;
    byte inoseg:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte unspec_3:1;
  };
  byte b;
} trbioc_type;
#define trbioc (*(volatile trbioc_type *)0x10a)

typedef union {
  struct {
    byte tmod:2;
    byte unspec_0:1;
    byte twrc:1;
    byte tck:2;
    byte unspec_1:1;
    byte tckcut:1;
  };
  byte b;
} trbmr_type;
#define trbmr (*(volatile trbmr_type *)0x10b)

#define trbpre (*(volatile byte *)0x10c)
#define trbsc (*(volatile byte *)0x10d)
#define trbpr (*(volatile byte *)0x10e)

typedef union {
  struct {
    byte cks:3;
    byte unspec_0:1;
    byte unspec_1:1;
    byte mss:1;
    byte rsstp:1;
    byte unspec_2:1;
  };
  byte b;
} sscrh_type;
#define sscrh (*(volatile sscrh_type *)0xb8)

typedef union {
  struct {
    byte unspec_0:1;
    byte sres:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte solp:1;
    byte sol:1;
    byte unspec_3:1;
    byte unspec_4:1;
  };
  byte b;
} sscrl_type;
#define sscrl (*(volatile sscrl_type *)0xb9)

typedef union {
  struct {
    byte bc:3;
    byte unspec_0:1;
    byte unspec_1:1;
    byte cphs:1;
    byte cpos:1;
    byte mls:1;
  };
  byte b;
} ssmr_type;
#define ssmr (*(volatile ssmr_type *)0xba)

typedef union {
  struct {
    byte ceie:1;
    byte unspec_0:1;
    byte unspec_1:1;
    byte re:1;
    byte te:1;
    byte rie:1;
    byte teie:1;
    byte tie:1;
  };
  byte b;
} sser_type;
#define sser (*(volatile sser_type *)0xbb)

typedef union {
  struct {
    byte ce:1;
    byte unspec_0:1;
    byte orer:1;
    byte unspec_1:1;
    byte unspec_2:1;
    byte rdrf:1;
    byte tend:1;
    byte tdre:1;
  };
  byte b;
} sssr_type;
#define sssr (*(volatile sssr_type *)0xbc)

typedef union {
  struct {
    byte ssums:1;
    byte csos:1;
    byte soos:1;
    byte sckos:1;
    byte css:2;
    byte scks:1;
    byte bide:1;
  };
  byte b;
} ssmr2_type;
#define ssmr2 (*(volatile ssmr2_type *)0xbd)

#define sstdr (*(volatile byte *)0xbe)
#define ssrdr (*(volatile byte *)0xbf)

typedef union {
  struct {
    byte fmr00:1;
    byte fmr01:1;
    byte fmr02:1;
    byte fmr03:1;
    byte fmr04:1;
    byte fmr05:1;
    byte fmr06:1;
    byte fmr07:1;
  };
  byte b;
} fmr0_type;
#define fmr0 (*(volatile fmr0_type *)0x1b7)

typedef union {
  struct {
    byte fmr10:1;
    byte fmr11:1;
    byte fmr12:1;
    byte fmr13:1;
    byte fmr14:1;
    byte fmr15:1;
    byte fmr16:1;
    byte fmr17:1;
  };
  byte b;
} fmr1_type;
#define fmr1 (*(volatile fmr1_type *)0x1b5)

typedef union {
  struct {
    byte fmr40:1;
    byte fmr41:1;
    byte fmr42:1;
    byte fmr43:1;
    byte fmr44:1;
    byte fmr45:1;
    byte fmr46:1;
    byte fmr47:1;
  };
  byte b;
} fmr4_type;
#define fmr4 (*(volatile fmr4_type *)0x1b3)
#define ivec_brk 0
#define ivec_timer_rd0 8
#define ivec_timer_rd1 9
#define ivec_timer_re 10
#define ivec_key 13
#define ivec_adc 14
#define ivec_iic 15
#define ivec_s0tx 17
#define ivec_s0rx 18
#define ivec_s1tx 19
#define ivec_s1rx 20
#define ivec_int2 21
#define ivec_timer_ra 22
#define ivec_timer_rb 24
#define ivec_int1 25
#define ivec_int3 26
#define ivec_int0 29

#define set_ivect(f,n) \
  asm ("mov.w #%%lo16(%d0),_ivects+%d1"   : : "s" (f), "g" (n*4)); \
  asm ("mov.w #%%hi16(%d0),_ivects+%d1" : : "s" (f), "g" (n*4+2));
